package p2psim.test;

import java.util.*;
import junit.framework.*;
import p2psim.*;
import p2psim.commonapi.Id;
import java.math.BigInteger;

/**
 * @author <A href="javascript:main.compose('new','t=Ruben.Mondejar@estudiants.urv.es')">Ruben Mondejar</a>
 *
 */
 
public class SimpleTest extends TestCase {

    private Simulator sim;   		
	private Scheduler timer;
	private Vector events;
	
	public SimpleTest(String name) {
	super(name);
  }

  protected void setUp() {
		
    try {
  		
	Logger.setLevel(2);	
	Globals.QUEUE_SIZE=250;
  	Globals.T_Stabilitze=5;
  	Globals.T_FixFingers=5;  
	  
	} catch (Exception e1) {
	  e1.printStackTrace();	
	}	
  }


  public static junit.framework.Test suite() {
    return new TestSuite(SimpleTest.class);
  }
  
  
  // join 4 nodes in 20 steps
/*  
  public void testJoin() throws Exception {
  				
	events = EventParser.parseEvents("test_join.txt");
	
	timer = new Scheduler();
	timer.addEvents(events);
			
	sim = new Simulator(timer);			
	sim.run(100);		
	assertEquals(4,sim.getSizeRing());		
	
  } 

  public void testLeave() throws Exception {
  	
  	events = EventParser.parseEvents("test_leave.txt");
	
	timer = new Scheduler();
	timer.addEvents(events);
			
	sim = new Simulator(timer);			
	sim.run(100);		
	assertEquals(3,sim.getSizeRing());
  }
  
  public void testLookup() throws Exception {  
  				
	events = EventParser.parseEvents("test_lookup.txt");
	
	timer = new Scheduler();
	timer.addEvents(events);
			
	sim = new Simulator(timer);			
	sim.run(3000);	
	Id own = Results.getLookup(new ChordId(new int[]{54}));
	assertEquals("56",own.toString());		
	
  
  }

  public void testFail() throws Exception {
  	
  	events = EventParser.parseEvents("test_fail.txt");
	
	timer = new Scheduler();
	timer.addEvents(events);
			
	sim = new Simulator(timer);			
	sim.run(100);		
	assertEquals(2,sim.getSizeRing());
	
	sim.printNodes();
  }

  public void testStabilize() throws Exception {
	events = EventParser.parseEvents("test_join.txt");
	
	Id id0 = new ChordId(new int[]{0});
	Id id1 = new ChordId(new int[]{1});
	Id id3 = new ChordId(new int[]{3});
	Id id6 = new ChordId(new int[]{6});
	
	Hashtable succs = new Hashtable();
	succs.put(id0,id1);
	succs.put(id1,id3);
	succs.put(id3,id6);
	succs.put(id6,id0);
	
	Hashtable preds = new Hashtable();
	preds.put(id0,id6);
	preds.put(id1,id0);
	preds.put(id3,id1);
	preds.put(id6,id3);
	
	timer = new Scheduler();
	timer.addEvents(events);
			
	sim = new Simulator(timer);			
	sim.run(3000);	
	HashMap nodes = sim.getNodes();
	
	Collection keys = nodes.keySet();
	Iterator it = keys.iterator();
	while (it.hasNext()) {
	  Id key = (Id) it.next();
	  Node n = (Node) nodes.get(key);
	  Hashtable info = n.getInfo();
	  Id[] finger = (Id[]) info.get("finger");
	  Id predecessor = (Id) info.get("predecessor");
	  
	  assertEquals(succs.get(key).toString(),finger[0].toString());
	  assertEquals(preds.get(key).toString(),predecessor.toString());	
	}
  }
  
  public void testFixFingers() throws Exception {

	events = EventParser.parseEvents("test_join.txt");
	
	Id ids[] = new Id[4];
	
	ids[0]= new ChordId(new int[]{0});
	ids[1]= new ChordId(new int[]{1});
	ids[2]= new ChordId(new int[]{3});
	ids[3]= new ChordId(new int[]{6});		
	
	timer = new Scheduler();
	timer.addEvents(events);
			
	sim = new Simulator(timer);			
	sim.run(12000);	
	HashMap nodes = sim.getNodes();
	
	Collection keys = nodes.keySet();
	Iterator it = keys.iterator();
	while (it.hasNext()) {
	  Id key = (Id) it.next();
	  Node n = (Node) nodes.get(key);
	  Hashtable info = n.getInfo();
	  Id[] finger = (Id[]) info.get("finger");
	  Id[] start = (Id[]) info.get("start");
	  
	  int j=0; boolean find=false;
	  while (!find) {
	  	if (ids[j].toString().equals(key.toString())) find=true;
	  	j=(j+1)%4;
	  }	  
	  
	  int i=0;
	  boolean end = false;
	  while (i<Globals.K) {
	  	//Logger.log(start[i]+"<="+ids[j]+"?",Globals.ERROR_LOG);
	    if (start[i].toString().compareTo(ids[j].toString()) <=0 && !end) {	      
		  assertEquals(finger[i].toString(),ids[j].toString());		  
		  i++;
	    }  
	    else if (end || start[i].toString().compareTo(ids[3].toString()) > 0) {
		  assertEquals(finger[i].toString(),ids[0].toString());		
		  end=true;  
		  i++;  
	    }		
	    else {
		  j=(j+1)%4;	       
	    } 	
	  }	  	
	}  
  }   

  // join 1000 random nodes in 6000 steps

  public void test1000Join() throws Exception {
 	  	
    Id first = new ChordId(new int[]{1});	
    Id last = new ChordId(new int[]{1000});
    
	events = EventParser.parseEvents("test_join1000r.txt");
	
	timer = new Scheduler();
	timer.addEvents(events);
			
	sim = new Simulator(timer);			
	sim.run(6000);
	assertEquals(0,Results.getStabRate());
  } 
  
 
 // join 1000 distributed nodes in 6000 steps and in restore state lookup of 500 keys

  public void testRestoreState() throws Exception {
 	
 	int num = 1000;
 	int lookup_time = 7000;
	int n_lookups = 500;
	Hashtable results1, results2;	
 	
 	Object[] pack = GenEvents.genRandomIds(num);
	Id[] boot = (Id[]) pack[0];
 	Id[] nodes = (Id[]) pack[1];
 	
 	Vector events = new Vector();
 	//CREATE JOIN EVENTS
 	for(int i=0;i<num;i++) {
	  events.add(new Event(nodes[i],boot[i],Globals.JOIN,1,i*3));	  
 	}
	 	 	
    //CREATE LOOKUP EVENTS
	Vector lookupEvents = new Vector();	
	
	pack = GenEvents.genRandomIds(n_lookups+1);
	Id[] keys = (Id[]) pack[1];
	
	for(int i=0;i<=n_lookups;i++) {   	
	  lookupEvents.add(new Event(nodes[i],keys[i],Globals.LOOKUP,1,lookup_time+i*3)); 	 
	  //Logger.log("lookup "+keys[i]+" "+nodes[i]+" "+(lookup_time+i*3),Globals.ERROR_LOG); 	
	}		
	events.addAll(lookupEvents);		
	Globals.OUTFILE_NAME = "test_1000.dat";
	
	timer = new Scheduler();
	timer.addEvents(events);	
	
	Results.resetLookups();
	  		
	sim = new Simulator(timer);			
	sim.run(lookup_time+n_lookups*3+1000);
	//STOP 
    //SAVE RESULTS1
    results1 = Results.getAllLookups();
	Results.resetLookups();
	
	//CREATE LOOKUP EVENTS
	Vector lookupEvents2 = new Vector();	
	for(int i=0;i<=n_lookups;i++) {
	  Event event = (Event) lookupEvents.get(i);	  	  			
	  lookupEvents2.add(new Event(event.getFrom(),event.getTo(),Globals.LOOKUP,1,i*3)); 	  	
	}
	
	//RESTORE	
	Globals.INFILE_NAME = "test_1000.dat";	
	
	timer = new Scheduler();
	timer.addEvents(lookupEvents2);	
	  		
	sim = new Simulator(timer,true);			
	sim.run(n_lookups*3+1000);	
	results2 = Results.getAllLookups();
	
	for (int i=0;i<n_lookups;i++) {	  
	  assertEquals(results1.get(keys[i]),results2.get(keys[i]));
	}
	
  } 
  
*/
 // join 1000 distributed nodes in 6000 steps and in restore state lookup of 500 keys

  public void testFingerSize() throws Exception {
 	
 	int num = 100;
 	int lookup_time = 4000;
	int n_lookups = 100;	
	Globals.FT_SIZE=32;
	Globals.K=32;
	
	Hashtable results1, results2;	
 	
 	Object[] pack = GenEvents.genDistribEvents(num,32);
	Id[] boot = (Id[]) pack[0];
 	Id[] nodes = (Id[]) pack[1];
 	
 	Vector events = new Vector();
 	//CREATE JOIN EVENTS
 	for(int i=0;i<num;i++) {
	  events.add(new Event(nodes[i],boot[i],Globals.JOIN,1,i*3));	  
	  //Logger.log("Join "+nodes[i]+" "+boot[i]+" "+(i*200),Globals.ERROR_LOG); 	
 	}
	 	 	
    //CREATE LOOKUP EVENTS
	Vector lookupEvents = new Vector();	
	
	pack = GenEvents.genRandomIds(n_lookups+1,32);
	Id[] keys = (Id[]) pack[1];
	
	for(int i=0;i<n_lookups;i++) {   	
	  lookupEvents.add(new Event(nodes[i],keys[i],Globals.LOOKUP,1,lookup_time+i*3)); 	 
	  //Logger.log("lookup "+keys[i]+" "+nodes[i]+" "+(lookup_time+i*3),Globals.ERROR_LOG); 	
	}		
	events.addAll(lookupEvents);		
	
    //Calculate real results    
    results1 = new Hashtable();    
    for(int i=0;i<n_lookups;i++) {
    	
      BigInteger id1 = new BigInteger(keys[i].toString());
      BigInteger min = new BigInteger("2").pow(160);
      int pos = 0;
      for (int j=0;j<num;j++) {      	  
        BigInteger id2 = new BigInteger(nodes[j].toString()); 
        BigInteger sub = id2.subtract(id1);  
        if (sub.compareTo(BigInteger.ZERO)>=0 && sub.compareTo(min)<0) {
          min = sub;
          pos = j;
        }
      }      
      results1.put(keys[i],nodes[pos]);
    }          
		
	
	timer = new Scheduler();
	timer.addEvents(events);	
	
	  		
	sim = new Simulator(timer);			
	while(sim.simulate()) {}
		
	results2 = Results.getAllLookups();
		
   	for (int i=0;i<n_lookups;i++) {	  
	  assertEquals(results1.get(keys[i]),results2.get(keys[i]));
	 // Id key1 = (Id) results1.get(keys[i]);
	 // Id key2 = (Id) results2.get(keys[i]);
	 // Logger.log("key "+keys[i]+" -> "+key1+','+key2,Globals.ERROR_LOG);
	 // Logger.log("equals -->"+key1.equals(key2),Globals.ERROR_LOG);
	}
	
	Results.printHops();
	sim.printNodes();

  } 
  

/*  
  public void testSuccList() throws Exception {}
  

  
  public void testBroadcast() throws Exception {
  }
*/  

	
}