package planet.simulate;

import java.math.BigInteger;
import java.util.*;

import planet.chord.*;
//import planet.chordimpl.commonapi.*;
import planet.commonapi.*;
import planet.util.Properties;

/**
 * @author Ruben Mondejar
 *
 */
public class GenEvents {
	
	/**
	 * Generate a set of random ids for nodesto insert to Chord ring.
	 * The generated values are node's id and nodes' bootstrap.
	 * @param num Number of nodes to generate.
	 * @return An array of two positions with: in first position the
	 * id node bootstrap of the node 'i'th; in second position the id of
	 * node 'i'th. 
	 */
	public static Object[] genRandomIds(int num) {
		
		Hashtable values = new Hashtable();
		HashSet control = new HashSet();
		
		//Ranlux random = new Ranlux();
		
		Id value = new ChordId(new int[]{0});
		
		int j=0;
		while(values.size()<num) {
		  do {	      
		    //value = new ChordId(new StringBuffer(new Double(random..raw()*Math.pow(2,160)).toString()));
		    value = new ChordId(new java.math.BigInteger(160,new java.util.Random()).toString());
		  } while (control.contains(value));	         		      	 
		  control.add(value);
		  values.put(new Integer(j),value);
		  j++;	      
		}	     			
		
		Id[] node = new Id[num];
		Id[] boot = new Id[num];
		
		node[0]=new ChordId(new int[]{0});
		boot[0]=new ChordId(new int[]{0});
		
		for(int i=1;i<num;i++) {	 
		  node[i] = (Id) values.get(new Integer(i));
		  		            			  
		  values.remove(value);
		  
		  int pos = (int) (Math.random()*(i-1) + 1);
		  boot[i] = node[pos];
		}		
		
		boot[1]=new ChordId(new int[]{0});
		Object[] ids = new Object[2];
		ids[0]=boot;
		ids[1]=node;
		return ids;
	}
	
	public static Object[] genDistribEvents(int num)  {
		
	        BigInteger MAX = new BigInteger("2").pow(Properties.bitsKey);

	        BigInteger div = new BigInteger(Integer.toString(num));

	        BigInteger res = MAX.divide(div);         

	        Id chunk = new ChordId (res.toString());

	        Id value = new ChordId(new int[]{0});

	        Id[] node = new Id[num];

	        Id[] boot = new Id[num];
	 	    
	 	    node[0] = value;

	        boot[0] = value;

	        for(int j = 1; j < num; j++) {

	          value = value.add(chunk);

	          node[j] = value;

	          int pos = (int) (Math.random()*(j-1) + 1);

	          boot[j] = node[pos];

	        }		
			
			boot[1]=node[0];
			Object[] ids = new Object[2];
			ids[0]=boot;
			ids[1]=node;
			return ids;
			
		}
		
		public static Id[] genRandomIds(Id min,int num, int k) {
			
			Hashtable values = new Hashtable();
			HashSet control = new HashSet();
			
			//Ranlux random = new Ranlux();
			
			Id value = new ChordId(new int[]{0});
			
			int j=0;
			while(values.size()<num) {
			  do {	      
			    value = new ChordId(new java.math.BigInteger(k,new java.util.Random()).toString());
			  } while (control.contains(value) || value.compareTo(min)<=0);	         		      	 
			  control.add(value);
			  values.put(new Integer(j),value);
			  j++;	      
			}	     			
			
			Id[] node = new Id[num];
			
			node[0]=new ChordId(new int[]{0});
			
			for(int i=1;i<num;i++) {	 
			  node[i] = (Id) values.get(new Integer(i));		  		            			  
			  values.remove(value);
			}			

			return node;
		}

}
