package planet.simulate;

import java.util.*;
import java.io.*;

import planet.commonapi.*;
import planet.commonapi.exception.InitializationException;
import planet.generic.commonapi.factory.GenericFactory;
import planet.util.Properties;

import java.math.BigInteger;

/**
 * @author Ruben Mondejar
 *
 */
public class GenFileEvents {
	
	public static void genRandomEvents(String name,int num, int time) 
			throws IOException,FileNotFoundException, InitializationException {
		
		Hashtable values = new Hashtable();
		HashSet control = new HashSet();
		
		Id value = GenericFactory.buildId(new int[]{0});
		
		int j=0;
		while(values.size()<num) {
		  do {	      
		    value = GenericFactory.buildId(new BigInteger(Properties.bitsKey,new java.util.Random()));
		  } while (control.contains(value));	         		      	 
		  control.add(value);
		  values.put(new Integer(j),value);
		  j++;	      
		}	     			
		
		Id[] node = new Id[num];
		Id[] boot = new Id[num];
		
		node[0] = GenericFactory.buildId(new int[]{0});
		boot[0] = GenericFactory.buildId(new int[]{0});
		
		for(int i=1;i<num;i++) {	 
		  node[i] = (Id) values.get(new Integer(i));
		  		            			  
		  values.remove(value);
		  
		  int pos = (int) (Math.random()*(i-1) + 1);
		  boot[i] = node[pos];
		}		
		
		boot[1] = GenericFactory.buildId(new int[]{0});
		PrintStream pr = new PrintStream(new FileOutputStream(name));
		
		for(int i=0;i<num;i++) {
		  pr.println("at "+i*time+" JOIN "+node[i]+" "+boot[i]+" 1");
		}		
		
		pr.close();		
	}
	
	public static void genDistribEvents(String name,int num, int time) throws IOException,FileNotFoundException, InitializationException {
		
		Hashtable values = new Hashtable();		
		
		BigInteger MAX = new BigInteger("2").pow(Properties.bitsKey);
		BigInteger div = new BigInteger(Integer.toString(num));
		BigInteger res = MAX.divide(div);		
		Id chunk = GenericFactory.buildId(res);
				
		Id value = GenericFactory.buildId(new int[]{0});
		
		int j=0;
		while(values.size()<num) {		  	      
		  value = value.add(chunk);			
		  values.put(new Integer(j),value);
		  j++;	      
		}	     			
		Id[] node = new Id[num];
		Id[] boot = new Id[num];
		
		node[0] = GenericFactory.buildId(new int[]{0});
		boot[0] = GenericFactory.buildId(new int[]{0});
		
		for(int i=1;i<num;i++) {  
		  node[i] = (Id) values.get(new Integer(i));
		  		            			  
		  values.remove(value);
		  
		  int pos = (int) (Math.random()*(i-1) + 1);
		  boot[i] = node[pos];
		}			
		
 	    boot[1] = GenericFactory.buildId(new int[]{0});
		
		PrintStream pr = new PrintStream(new FileOutputStream(name));
		
		for(int i=0;i<num;i++) {
		  pr.println("at "+i*time+" JOIN "+node[i]+" "+boot[i]+" 1");
		}		
		
		pr.close();
	}

	public static void main(String[] args) throws Exception {
		
		String name = args[0];
		String type = args[1];
		
		String number = args[2];
		int num = Integer.parseInt(number);	
		
		String step_time = args[3];
		int time = Integer.parseInt(step_time);	
		Properties.init("../conf/factories.properties","../conf/sim.properties","../conf/chord.properties");
		GenericFactory.init();
		
		if (type.charAt(0)=='R') {
		  genRandomEvents(name,num,time);
		}
		else {
		  genDistribEvents(name,num,time);
		} 		
	}
}

