package planet.symphony;

import planet.commonapi.*;

public class SuccSetComparator implements java.util.Comparator {

	Id rootId;
	
	public SuccSetComparator(Id rootId) {
		this.rootId = rootId;
	}
	
	public int compare(Object o1, Object o2) {
		Id id1 = ((NodeHandle) o1).getId();
		Id id2 = ((NodeHandle) o2).getId();

		if (id1.equals(id2))
			return 0;
			
		if (id1.equals(rootId))
			return 1;
			
		if (id2.equals(rootId))
			return -1;
		
		Id sub1 = id1.subtract(rootId);
		Id sub2 = id2.subtract(rootId);
		return sub1.compareTo(sub2);
	}

	public boolean equals(Object obj) {
		return (obj == this) || compare( ((SuccSetComparator)obj).rootId, rootId) == 0;
	}

}
