package planet.test.factory;

import planet.commonapi.exception.InitializationException;
import planet.commonapi.factory.*;
import planet.generic.commonapi.GenericApp;
import planet.generic.commonapi.factory.*;
import planet.commonapi.*;

/**
 * Simple test that builds an ApplicationFactory and an Application using it.
 * @author Jordi Pujol
 */
public class TestAppFactory extends GenericApp {
	/**
	 * Buils an instance of ApplicationFactory and a Application and
	 * prints its class.
	 */
	public TestAppFactory() throws InitializationException {
		super("../conf/factories.properties","../conf/sim.properties","../conf/chord.properties");
		ApplicationFactory nf = null;
		try {
			nf = GenericFactory.getApplicationFactory();
		} catch (Exception e) {
			System.out.println("Error creating factory... ");
			e.printStackTrace();
			return;
		}
		
		try {
			Application app = nf.build();
			System.out.println("I'm an instance of ["+
					app.getClass().getName() +
					"] with default Id = [" +app.getId()+"].");
			app = nf.buildWithName("TestApp");
			System.out.println("I'm an instance of ["+
					app.getClass().getName() +
					"] with Id = [" +app.getId()+"].");
		} catch (InitializationException e) {
			System.out.println("Error creating Application...");
			e.printStackTrace();
		}
	}
	
	/**
	 * Test the ApplicationFactoryImpl.
	 * @param args Waiting nothing.
	 */
	public static void main(String[] args) {
		try {
			new TestAppFactory();
		} catch (InitializationException e) {
			System.out.println("TestAppFactory: Exception thrown....");
			e.printStackTrace();
		}
	}
}
