package planet.test.serialize;

import java.util.Vector;

import planet.generic.commonapi.factory.GenericFactory;
import planet.simulate.EventParser;
import planet.simulate.NetworkSimulator;
import planet.simulate.Scheduler;
import planet.util.Properties;
/**
 * Builds a network based with events file "test_join1000d.txt" and serialize 
 * obtained network.
 * @author Ruben Mondejar
 * @author Jordi Pujol
 */
 
public class GenSerializedFile {

	/**
	 * Builds a network based with events file "test_join1000d.txt" and
	 * serialize it to file "test_1000.dat".
	 * @param args Nothing waiting.
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		//init context
		Properties.init("../conf/factories_serialized.properties","../conf/sim_serialized.properties","../conf/chord.properties");
		GenericFactory.init();

		//load events
		Vector events = EventParser.parseEvents(Properties.eventFile);
		Scheduler timer = new Scheduler();
		timer.addEvents(events);
			
		//build network and add all events
		long t1,t2;
		t1 = System.currentTimeMillis();
		NetworkSimulator sim = new NetworkSimulator(timer);
		sim.stabilize();
		t2 = System.currentTimeMillis();
		int steps = sim.getInternalNetwork().getSimulatedSteps();
		System.out.println("Simulation time ["+((t2-t1)/1000)+"] seconds for 1000 nodes with ["+steps+"] steps.");
		sim.saveState();
	}
}
