package planet.test.serialize;


import planet.commonapi.Network;
import planet.generic.commonapi.factory.GenericFactory;
import planet.generic.commonapi.factory.Topology;
import planet.util.Properties;
/**
 * Builds a network based with a serialized network specified in the
 * properties file. 
 * @author Ruben Mondejar
 * @author Jordi Pujol
 */
 
public class LoadSerializedFile {

	/**
	 * Loads a serialized network from the specified serialized file
	 * at properties file.
	 * @param args Waiting nothing.
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		//init context
		Properties.init("../conf/factories_serialized.properties","../conf/sim_serialized.properties","../conf/chord.properties");
		Properties.networkSize = 0;
		Properties.topology = Topology.SERIALIZED;
		GenericFactory.init();
		System.out.println("Properties.serializedFile = "+Properties.serializedFile);

		//loads network.
		long t1,t2;
		t1 = System.currentTimeMillis();
		Network net = GenericFactory.buildNetwork();
		t2 = System.currentTimeMillis(); 
		int steps = net.getSimulatedSteps();
		System.out.println("Load time ["+((t2-t1)/1000)+"] seconds for 1000 nodes with ["+steps+"] steps.");
	}
}
